            /////////////////////////////////////////////
            // ##### #### ###  // THE TI FONT PROJECT  //
            //   #   #    #  # // BY THE janjanII team //
            //   #   ##   ###  //////////////////////////
            //   #   #    #    //   C library v0.6     //
            /////////////////////////////////////////////
            //     internet: http://www.j2t.fr.st/     //
            //       mail: j2t@multimania.com          //
            /////////////////////////////////////////////
            //           sous license GPL              //
///POUR PLUS D'INFORMATIONS://////////////////////////////////////////
//voir le fichier readme.html inclus dans le pack                   //
///LICENSE////////////////////////////////////////////////////////////
//Ce logiciel est soumis aux droits de la license publique gnrale //
//disponible dans le fichier GPL.txt joint dans ce package          //
//sous la forme d' un texte ascii ou  l' URL:                      //
//    [http://www.j2t.fr.st/docs/GPL.txt]                           //
///POUR OBTENIR LA DERNIERE VERSION///////////////////////////////////
//rendez vous sur le site de la janjan2team, rubrique download      //
//Ce logiciel est fait pour fonctionner sans shell ni bibliothque  //
///UTILISATION ET COMPATIBILITE///////////////////////////////////////
//Cette librairie est faite pour tre utilise avec TIGCC:          //
//  [http://tigcc.ticalc.org/] pour la version windows              //
//    [http://lpg.ticalc.org/] pour la version Linux                //
//////////////////////////////////////////////////////////////////////




#ifndef TFP_INCLUDED //pour eviter les inclusions multiples(1)...

///MACROS/////////////////////////////////////////////////////////////
#define ADRESSE(x,y) (Plane+((y-1)<<5)-((y-1)<<1)+((x-1)>>3))       //
#define MASQUE(x)     ((unsigned char)(0x80) >> ((x-1)&7))          //
///CONSTANTES/////////////////////////////////////////////////////////
#define NORMAL    0b00000001 //police normale                       //
#define UNDERLINE 0b00000111 //police souligne                     //
#define BARRE     0b00000101 //police barre                        //
#define BOLD      0b00001000 //police gras                          //
                                                                    //
#define MODE_OR      XChar_OR      //noir                           //
#define MODE_XOR     XChar_XOR     //inverse le BG                  //
#define MODE_REPLACE XChar_REPLACE //fond blanc                     //
///TYPES//////////////////////////////////////////////////////////////
struct CHAR           //forme d'un caractre                        //
{                                                                   //
char Yoffset;         //decalage par rapport  au 'top'              //
char lar;             //largeur                                     //
char hau;             //hauteur                                     //
unsigned char map[12];//sprite                                      //
};                                                                  //
///VARIABLES//////////////////////////////////////////////////////////
struct CHAR *FONT; //Police utilise pour l'ffichage des strings    //
//Pour afficher le char a de cette police avec XChar()              //
//on utilise: XChar(x,y,FONT[(int)'a'],MODE_XX,plan);               //
//////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////
//XStrLen(char *str,short attr) calcule la longueur d'une chaine    //
//EN PIXELS et la retourne sous forme d'un entier.                  //
//////////////////////////////////////////////////////////////////////
int XStrLen(char *str,short attr)
{
short x=0;
if(attr!=BOLD) //police normale
{
	while((*str)!='\0') //le caractre nul termine la chaine.
	{
		x += 2+FONT[(int)*str].lar;//espace de 2px entre les caractres
		str++;
	}
return(x-2); //retourne la longueur de la chaine
}
else           //police gras
	while((*str)!='\0')
	{
		x += 3+FONT[(int)*str].lar;//espace de 3px entre les caractres
		str++;
	}
return(x-3); //retourne la longueur de la chaine en gras
}


//////////////////////////////////////////////////////////////////////
//ToChar(short Y,short l,short h,char m[0]) permet de crer         //
//facilement un caractre, elle prends des donnes et les restitue  //
//sous forme de caractre (struct CHAR).                            //
//////////////////////////////////////////////////////////////////////
struct CHAR ToChar(short Y,short l,short h,char m[0])
{
struct CHAR temp ={Y,l,h,{m[0],m[1],m[2],m[3],m[4],m[5],m[6],m[7],m[8],m[9],m[10],m[11]}};
return temp;
}

//////////////////////////////////////////////////////////////////////
//dessine une ligne horizontale(utilis pour souligner ou barre)    //
//attention, si vous vous servez de cette fonctions indpendement,  //
//il faut de x soit inferieur  x2.(sous peine de GROS bug)         //
//cette gestion n'a pas t implmente pour des raisons de rapidit//
//fonction utilise par XStr                                        //
//////////////////////////////////////////////////////////////////////
void HLine(short x,short x2,short y,unsigned char *Plane)
{
unsigned char *P2 =ADRESSE(x2,y);
*ADRESSE(x,y) |= 255>>((x-1)&7);      //debut de ligne
*ADRESSE(x2,y) |= ~(255>>((x2-1)&7)); //fin de ligne

Plane=ADRESSE(x,y); 
	while(Plane<P2)  //remplisagge de la ligne
	{
		Plane++;
		*Plane=255; //on procde par byte pour un plus grande rapidit
	}
}

//////////////////////////////////////////////////////////////////////
//dessine un caractre en OR dans le plan dlectionn               //
//fonction utilise par XStr                                        //
//////////////////////////////////////////////////////////////////////
void XChar_OR(unsigned short x,register unsigned char *map,short hau,unsigned char offset,unsigned char *Plane)
{
Plane += offset;
Plane += x>>3; //adresse de la premiere ligne du sprite
x&=7;
while(hau)
{  
	*Plane |= (*map)>>x;         //avant la sparation du sprite entre 2 Bytes
	*(Plane+1) |= (*map)<<(8-x); //aprs la sparation
	Plane +=30; //une ligne au dessous
	map++;
	hau--;
}
}

//////////////////////////////////////////////////////////////////////
//dessine un caractre en XOR dans le plan dlectionn              //
//fonction utilise par XStr                                        //
//////////////////////////////////////////////////////////////////////
void XChar_XOR(unsigned short x,register unsigned char *map,short hau,unsigned char offset,unsigned char *Plane)
{
Plane += offset; //adresse de la premiere ligne du sprite
Plane += x>>3; //adresse de la premiere colonne du sprite
x&=7;
while(hau)
{  
	*Plane ^= (*map)>>x;         //avant la sparation du sprite entre 2 Bytes
	*(Plane+1) ^= (*map)<<(8-x); //aprs la sparation
	Plane +=30;
	map++;
	hau--;
}
}

//////////////////////////////////////////////////////////////////////
//dessine un caractre en REPLACE dans le plan dlectionn          //
//fonction utilise par XStr                                        //
//////////////////////////////////////////////////////////////////////
void XChar_REPLACE(unsigned short x,register unsigned char *map,short hau,unsigned char offset,unsigned char *Plane)
{
Plane += offset;
Plane += x>>3; //adresse de la premiere ligne du sprite
x&=7;
while(hau)
{  
	*Plane = (*Plane&255<<(8-x))|(*map)>>x;         //avant la sparation du sprite entre 2 Bytes
	*(Plane+1) = (*Plane&255>>x)|(*map)<<(8-x); //aprs la sparation
	Plane +=30; //une ligne au dessous
	map++;
	hau--;
}
}
//////////////////////////////////////////////////////////////////////
//dessine un charactere dans le plan dlectionn, x et y en pixels. //
//les attributs sont MODE_OR, MODE_XOR, MODE_REPLACE                //
//description en dbut de fichier.                                  //
//////////////////////////////////////////////////////////////////////
void XChar(unsigned short x,unsigned short y,struct CHAR C,void (*mode)(unsigned short,unsigned char*,short,unsigned char,unsigned char*),unsigned char *Plane)
{
   x--;
   y--;
   Plane += y<<5;
   Plane -= y<<1;
   mode(x,C.map,C.hau,C.Yoffset,Plane);
}

//////////////////////////////////////////////////////////////////////
//dessine une chaine dans le plan dlectionn, x et y en pixels.    //
//les decorations sont NORMAL,UNDERLINE,BARRE,BOLD                  //
//les attributs sont MODE_OR, MODE_XOR, MODE_REPLACE                //
//description en dbut de fichier.                                  //
//////////////////////////////////////////////////////////////////////
//derniere optimisation:   28 aout 2001                             //
//////////////////////////////////////////////////////////////////////
void XStr(short x,short y,char *str,short attr,void (*mode)(unsigned short,unsigned char*,short,unsigned char,unsigned char*),unsigned char *Plane)
{
short l=6;
struct CHAR *C;
x--;
y--;
if(attr&0b00000010)l+=5;
if(attr&0b00000100)HLine(x,x+XStrLen(str,attr),y+l,Plane);
if(attr&0b00000001)
{   Plane += y<<5;
    Plane -= y<<1;
		while(*str)
		{
		  C=&FONT[(int)*str];
			mode(x,(*C).map,(*C).hau,(*C).Yoffset,Plane);
			x += 2;
			x += (*C).lar; //on augmente x de la largeur du caractre +2
			str++;                      //correspondant  l'espace entre les caractres
		}
}
if(attr&0b00001000)//BOLD
{   Plane += y<<5;
    Plane -= y<<1;
	while(*str)
	{
	  C=&FONT[(int)*str];
		mode(x,(*C).map,(*C).hau,(*C).Yoffset,Plane);  //pour ecrire en gras, la chaine est rcrite
		mode(x+1,(*C).map,(*C).hau,(*C).Yoffset,Plane);  //1 px vers la droite ce qui ralentit.
		x += 3;
		x += (*C).lar;
		str++;
   }
}
}

//////////////////////////////////////////////////////////////////////
//ici on ouvre un fichier du nom de buf et on verifie s'il fait la  //
//bonne taille.                                                     //
//c'est un mystre pour moi mais les fichiers sauvegards avec      //
//l'diteur font 4000 octets et lorsqu'on les transmet sur PC et    //
//q'uon les renvoient ils font 3834 octets!!!!(le varlink affiche   //
//dans les 2 cas 3834!) les caractres sont stocks dans le tableau //
//FONT pour tre utiliss par XStr.                                 //
//////////////////////////////////////////////////////////////////////
short OpenFont(char buf[8])
{
FILE *font;
	if((font = fopen(buf,"rb"))) //lecture seule, mode binaire
	{
		if(((*font).alloc==(unsigned long)3834)||((*font).alloc==(unsigned long)4000))
		{
			memcpy(FONT,(*font).fpos,15*255); //copie dans FONT
			fclose(font);
		  return(1);//si tout a march, on retourne 1
  	}
		else
		  return(0);
	}
	else
 		 return(0);
}


//////////////////////////////////////////////////////////////////////
//fonction  appeler en dbut d'utilisationde TFP OBLIGATOIREMENT!!!//
//pour allouer la mmoire de FONT et initialiser les caractres  0 //
//////////////////////////////////////////////////////////////////////
void allocmemtfp()
{
short i;
if((FONT = malloc(15*255))==NULL)
	exit(0);  //si on rencontre un problme mmoire, on quitte le programme arbitrairement.
for(i=0;i<255;i++)
	FONT[i] = ToChar(0,8,12,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");//Yoffset:0,lar:8,hau:12,map:blank
}

//////////////////////////////////////////////////////////////////////
//macros d'utilisation pour plus de simplicit et de concision.     //
//elles se terminent toutes par _TFP.                               //
//////////////////////////////////////////////////////////////////////
#define BEGUSE_TFP()          allocmemtfp()   //dbut d'utilisation
#define CONFIG_TFP(x)         OpenFont(x)     //configuration de la police
#define ENDUSE_TFP()          free(FONT)      //fin d'utilisation
#define CHARAC_TFP(a,b,c,d)   XChar(a,b,c,d,e)//criture d'un caractre
#define CHAINE_TFP(a,b,c,d,e) XStr(a,b,c,d,e) //criture d'une chaine
//////////////////////////////////////////////////////////////////////

#define TFP_INCLUDED //pour eviter les inclusions multiples(2)...
#endif //pour eviter les inclusions multiples(3)





//////////////////////////////////////////////////////////////////////
//                         End Of File                              //
//////////////////////////////////////////////////////////////////////
//    si vous rajoutez des fonctions, faites le apres ces ligne     //
//////////////////////////////////////////////////////////////////////
