void draw_start(void)
{
  short i=64;
  unsigned char *s0=titre_0,*s1=titre_1,*p0=pl0+605,*p1=pl1+605;
  while(i)
	{
		memcpy(p0,s0,20);
		memcpy(p1,s1,20);
		s0+=20;
		s1+=20;
		p0+=30;
		p1+=30;
		i--;
	}
}

void draw_fond(void)
{
  short i=111;
  unsigned char *s0=fond_0,*s1=fond_1,*p0=pl0+242,*p1=pl1+242;
  while(i)
	{
		memcpy(p0,s0,25);
		memcpy(p1,s1,25);
		s0+=25;
		s1+=25;
		p0+=30;
		p1+=30;
		i--;
	}
}

void spr24(short x,short y,short h,unsigned char* sprite,unsigned char* mask,void* dest) {
    register unsigned char  *addr  = ((unsigned char*)dest)+((y<<5)-(y<<1)+(x>>3));
    register unsigned short  shift1 = x & 7;
    register unsigned short  shift2;
    register unsigned short  lineoffset = 27;
    register unsigned short  loop;
    register unsigned char   startmask;
    register unsigned char   endmask;

    if (shift1) {
        shift2 = 8 - shift1;
        startmask = 0xff << shift2;
        endmask   = 0xff >> shift1;
        for (;h;h--,addr+=lineoffset) {
            *addr   &= ((*mask) >> shift1) | startmask;
            *addr++ |= *sprite >> shift1;
            for (loop=1;loop<3;loop++) {
               unsigned char val = (*mask++) << shift2;
               *addr   &= val | ((*mask) >> shift1);
               *addr   |= ((*sprite++) << shift2);
               *addr++ |= (*sprite >> shift1);
            }
            *addr &= ((*mask++) << shift2) | endmask;
            *addr |= (*sprite++ << shift2);
        }
    }
    else {
        for (;h;h--,addr+=lineoffset) {
            for (loop=0;loop<3;loop++) {
                *addr   &= *mask++;
                *addr++ |= *sprite++;
            }
        }
    }
}

void spr32(short x,short y,short h,unsigned char* sprite,unsigned char* mask,void* dest) {
    register unsigned char  *addr  = ((unsigned char*)dest)+((y<<5)-(y<<1)+(x>>3));
    register unsigned short  shift1 = x & 7;
    register unsigned short  shift2;
    register unsigned short  lineoffset = 26;
    register unsigned short  loop;
    register unsigned char   startmask;
    register unsigned char   endmask;

    if (shift1) {
        shift2 = 8 - shift1;
        startmask = 0xff << shift2;
        endmask   = 0xff >> shift1;
        for (;h;h--,addr+=lineoffset) {
            *addr   &= ((*mask) >> shift1) | startmask;
            *addr++ |= *sprite >> shift1;
            for (loop=1;loop<4;loop++) {
               unsigned char val = (*mask++) << shift2;
               *addr   &= val | ((*mask) >> shift1);
               *addr   |= ((*sprite++) << shift2);
               *addr++ |= (*sprite >> shift1);
            }
            *addr &= ((*mask++) << shift2) | endmask;
            *addr |= (*sprite++ << shift2);
        }
    }
    else {
        for (;h;h--,addr+=lineoffset) {
            for (loop=0;loop<4;loop++) {
                *addr   &= *mask++;
                *addr++ |= *sprite++;
            }
        }
    }
}

void draw_marteau_down(short x,short y)
{
	spr24(x,y,25,marteau1_0,marteau1_m,pl0);
	spr24(x,y,25,marteau1_1,marteau1_m,pl1);
}

void virtTOscr(void)
{
	memcpy(GetPlane(0),pl0,3840);
	memcpy(GetPlane(1),pl1,3840);
}

void affiche(short x,short y,short x2,short y2)
{
	draw_fond();
	spr32(x2,y2,24,enemy_0,enemy_m,pl0);
	spr32(x2,y2,24,enemy_1,enemy_m,pl1);
	spr24(x,y,38,marteau0_0,marteau0_m,pl0);
	spr24(x,y,38,marteau0_1,marteau0_m,pl1);
	virtTOscr();
}
